minor bug fix
[distro-setup] / btrbk-run
index 5c1439824c9ea4dabb17879e83a7859e4a95bbc8..10bd6382c65df24a4ec1efe35a45270e70ad9005 100644 (file)
--- a/btrbk-run
+++ b/btrbk-run
 
 # todo: if we cancel in the middle of a btrfs send, then run again immediately, the received subvolume doesn't get a Received UUID: field, and we won't mount it. Need to figure out a solution that will fix this.
 
-err-bash-trace() {
-  local -i argc_index=0 frame i start=${1:-0} max_indent=8 indent
-  local source
-  local extdebug=false
-  if [[ $(shopt -p extdebug) == *-s* ]]; then
-    extdebug=true
-  fi
-  for ((frame=0; frame < ${#FUNCNAME[@]}-1; frame++)); do
-    argc=${BASH_ARGC[frame]}
-    argc_index+=$argc
-    ((frame < start)) && continue
-    if (( ${#BASH_SOURCE[@]} > 1 )); then
-      source="${BASH_SOURCE[frame+1]}:${BASH_LINENO[frame]}:"
-    fi
-    indent=$((frame-start + 1))
-    indent=$((indent < max_indent ? indent : max_indent))
-    printf "%${indent}s↳%sin \`%s" '' "$source" "${FUNCNAME[frame]}"
-    if $extdebug; then
-      for ((i=argc_index-1; i >= argc_index-argc; i--)); do
-        printf " %s" "${BASH_ARGV[i]}"
-      done
-    fi
-    echo \'
-  done
-  return 0
-}
-err-catch() {
-  set -E; shopt -s extdebug
-  _err-trap() {
-    err=$?
-    exec >&2
-    set +x
-    echo "${BASH_SOURCE[1]}:${BASH_LINENO[0]}: \`$BASH_COMMAND' returned $err"
-    err-bash-trace 2
-    set -e # err trap does not work within an error trap
-    "${_errcatch_cleanup[@]:-:}" # note :-: is to be compatible with set -u
-    echo "$0: exiting with code $err"
-    exit $err
-  }
-  trap _err-trap ERR
-  set -o pipefail
-}
-err-catch
-
 
-[[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
+[[ $EUID == 0 ]] || exec sudo -E "${BASH_SOURCE[0]}" "$@"
 
+source /usr/local/lib/err
 
 usage() {
   cat <<'EOF'
@@ -85,9 +42,10 @@ rsync-dirs() {
 }
 
 
-pre="${0##*/}:"
-m() { if $verbose; then printf "$pre %s\n"  "$*"; fi;  "$@"; }
-die() { printf "$pre %s\n" "$*" >&2;  exit 1; }
+pre="${0##*/}: "
+m() { if $verbose; then printf "$pre%s\n"  "$*"; fi;  "$@"; }
+e() { printf "$pre%s\n"  "$*"; }
+die() { printf "$pre%s\n" "$*" >&2;  exit 1; }
 
 # latest $MAIL_HOST
 if [[ -e /b/bash_unpublished/source-state ]]; then
@@ -167,7 +125,7 @@ if [[ -v targets && $source ]]; then
 fi
 
 if $verbose; then
-  printf "$pre options: conf_only=%s\ndry_run=%s\nrate_limit=%s\nverbose=%s\ncmd_arg=%s" "$conf_only" "$dry_run" "$rate_limit" "$verbose" "$cmd_arg"
+  printf "options: conf_only=%s\ndry_run=%s\nrate_limit=%s\nverbose=%s\ncmd_arg=%s" "$conf_only" "$dry_run" "$rate_limit" "$verbose" "$cmd_arg"
 fi
 ### end options parsing
 
@@ -180,9 +138,21 @@ if [[ ! -v targets && ! $source ]]; then
     echo "MAIL_HOST=$MAIL_HOST, nothing to do"
     exit 0
   fi
+
+  at_work=false
+
   case $HOSTNAME in
-    kw|x2)
-      if ping -q -c1 -w1 iank.vpn.office.fsf.org &>/dev/null; then
+    kw)
+      at_work=true
+      ;;&
+    x2|x3)
+      if ping -q -c1 -w1 hal.office.fsf.org \
+              && ip n show 192.168.0.26 | grep . &>/dev/null; then
+      at_work=true
+      fi
+      ;;&
+    kw|x2|x3)
+      if $at_work && ping -q -c1 -w1 iank.vpn.office.fsf.org &>/dev/null; then
         home=iank.vpn.office.fsf.org
       else
         home=b8.nz
@@ -191,11 +161,13 @@ if [[ ! -v targets && ! $source ]]; then
     kw)
       targets=($home x2)
       ;;
-    x2)
+    x2|x3)
       targets=($home kw)
       ;;
     tp)
-      targets=(frodo kd)
+      # kd disabled temporarily while its hot and i plan to work on it.
+      #targets=(frodo kd)
+      targets=(frodo x3.b8.nz)
       # might not be connected to the vpn
       if timeout -s 9 10 ssh kw :; then
         targets+=(kw)
@@ -254,7 +226,7 @@ else
   esac
   for mp in ${prospective_mps[@]}; do # default mountpoints to sync
     if [[ -e /nocow/btrfs-stale/$mp ]]; then
-      echo "$pre warning: $mp stale, not adding to default mountpoints"
+      e "warning: $mp stale, not adding to default mountpoints"
       continue
     fi
     if awk '{print $2}' /etc/fstab | grep -xF $mp &>/dev/null; then
@@ -287,7 +259,7 @@ if ! $pull_reexec && [[ $source ]] && $pulla ; then
   tmpf=$(mktemp)
   scp $source:/a/bin/distro-setup/btrbk-run $tmpf
   if ! diff -q $tmpf $BASH_SOURCE; then
-    echo "$pre found newer version on host $source. reexecing"
+    e "found newer version on host $source. reexecing"
     install -T $tmpf /usr/local/bin/btrbk-run
     m /usr/local/bin/btrbk-run --pull-reexec "${orig_args[@]}"
     exit
@@ -324,12 +296,17 @@ else
   min_idle_ms=$((1000 * 60 * 15))
   for h in ${targets[@]}; do
     if zone=$(ssh root@$h "mkdir -p /mnt/root/btrbk && date +%z"); then
-      if $cron && DISPLAY=:0 xprintidle; then
-        # This is a separate ssh because xprintidle can fail and thats ok.
-        # Ignore this host. i sometimes use a non-main machine for testing or web browsing, knowing that
-        # everything will be wiped by the next backup, but I dont want it to happen as Im using
-        # it from cronjob.
-        continue
+      # This is a separate ssh because xprintidle can fail and thats ok.
+      if $cron && idle_ms=$(ssh $h DISPLAY=:0 xprintidle); then
+        if (( idle_ms < min_idle_ms )); then
+
+          # Ignore this host. i sometimes use a non-main machine for
+          # testing or web browsing, knowing that everything will be wiped
+          # by the next backup, but I dont want it to happen as Im using
+          # it from cronjob.
+          e "warning: $h: active X session in the last 15 minutes, skipping for now"
+          continue
+        fi
       fi
       sshable+=($h)
       if [[ $zone != $local_zone ]]; then
@@ -339,12 +316,12 @@ else
       sshfail+=($h)
     fi
   done
-  if [[ ! $sshable ]] || { ! $cron && [[ $sshfail ]]; }; then
+  if [[ ! ${sshable[@]} ]] || { ! $cron && [[ ${sshfail[@]} ]]; }; then
     die "failed to ssh to hosts: ${sshfail[*]}"
   else
-    if [[ $sshfail ]]; then
+    if [[ ${sshfail[@]} ]]; then
       ret=1
-      echo "$pre error: failed to ssh to ${sshfail[*]} but continuing with other hosts"
+      e "error: failed to ssh to ${sshfail[*]} but continuing with other hosts"
     fi
     targets=(${sshable[@]})
   fi